stm8/ TITLE “mainRAM_echo.asm”

    #include "STM8S103F3P.inc"
    MOTOROLA
    WORDS
	
    segment byte at 0100 'some_RAM_segment'
start:
; настраиваем UART 9600/8N1
    mov    UART1_BRR2, #$0           ; [35 00 52 33]  для Fmaster=16/8=2МГц и 96000
    mov    UART1_BRR1, #$D           ; [35 0D 52 32]  для Fmaster=16/8=2МГц и 96000
; разрешаем передачу/прием
    mov    UART1_CR2, #%00001100     ; [35 0C 52 35]    UART1_CR2.TEN <- 1  UART1_CR2.REN <- 1
	
cycle:

; ожидаем получения байта из UART
wait_rx_byte:
    btjf   UART1_SR, #5, wait_rx_byte	; [72 0B 52 30 FB]
; включаем светодиод
    bset    PB_DDR,#5   ; [72 1A 50 07]
    bset    PB_CR1,#5   ; [72 1A 50 08]
	
; принимаем, инвертируем и отправляем байт по UART
	cpl    UART1_DR                    ; [72 53 52 31]
; ожидаем передачи байта по UART
wait_tx_byte:
	btjf   UART1_SR, #7, wait_tx_byte  ; [72 0F 52 30 FB]
; выключаем светодиод
    bres    PB_DDR,#5   ; [72 1B 50 07]
    bres    PB_CR1,#5   ; [72 1B 50 08]
	
    jra     cycle       ; [20 E0] 

    end
; mainRAM_echo.asm